using System;
using System.Collections;
using System.Text;

namespace SkeletaAnimation {
	public class Bone {

		private ArrayList childBones;
		private Bone parentBone;

		private Vector relativeTranslation;
		private Vector absoluteTranslation;

		private Quaternion relativeRotation;
		private Quaternion absoluteRotation;

		public Bone() {
			childBones = new ArrayList();
		}

		public void addChildBone(Bone child) {
			childBones.Add(child);
		}

		public void updateAbsoluteTransformation() {
			if(parentBone != null) {
				absoluteTransformation = parentBone.getAbsoluteTransformation() * relativeTransformation;
			}
			else {
				absoluteTransformation = relativeTransformation;
			}
		}

		// Getters and setters

		public ArrayList getChildBones() { return childBones; }

		public Bone getParentBone() { return parentBone; }
		public void setParentBone(Bone parent) { parentBone = parent; }

		public Matrix getRelativeTransformation() { return relativeTransformation; }
		public void setRelativeTransformation(Matrix relative) { relativeTransformation = relative; }

		public Matrix getAbsoluteTransformation() { return absoluteTransformation; }
	
	}
}
