using System;
using System.Collections;
using System.Text;

namespace SkeletalAnimation {
	
	public class Skeleton {

		#region Member Variables

		private SkeletonData skeletonData;

		private ArrayList joints;

		#endregion

		#region Constructors

		public Skeleton() {
			this.joints = new ArrayList();
			this.skeletonData = null;
		}

		#endregion

		#region Methods

		public Joint getJoint(uint index) {
			return (Joint)joints[(int)index];
		}

		/**
		 * Set the skeleton to bind pose
		 */
		public void setBindPose() {

			// Loop through all the joints and set the default rotation
			for(uint i=0; i<joints.Count; i++) {
				getJoint(i).setRelativeRotation(getJoint(i).getJointData().getRelativeRotation());
			}

			// Update the absolutes
			uint numJoints = (uint)joints.Count;
			for(uint i=0; i<numJoints; i++) {
				getJoint(i).updateAbsolutes();
			}
		}

		#endregion

		#region Getters & Setters

		// Getters & setters

		public SkeletonData getSkeletonData() { return this.skeletonData; }
		public void setSkeletonData(SkeletonData skelData) { this.skeletonData = skelData; }

		public ArrayList getJoints() { return this.joints; }
		public void setJoints(ArrayList joints) { this.joints = joints; }

		#endregion

	}
}
