using System;
using System.Collections;
using System.Text;
using Util;

namespace SkeletalAnimation {

	public class SkeletonData {

		private ArrayList jointData;

		#region Getters & Setters

		public void setJointData(ArrayList data) { jointData = data; }
		public ArrayList getJointData() { return jointData; }
		public JointData getJointData(int index) { return (JointData)jointData[index]; }

		#endregion

		

		#region Constructors

		/**
		 * Default constructor
		 */
		public SkeletonData() {
			jointData = new ArrayList();
		}

		#endregion

		#region Methods

		/**
		 * Create an instance of this skeleton
		 */
		public Skeleton createInstance() {
			Skeleton skeleton = new Skeleton();

			ArrayList joints = new ArrayList(jointData.Count);
			foreach(JointData jData in jointData) {
				Joint joint = new Joint(jData);
				joint.setSkeleton(skeleton);
				joints.Add(joint);
			}
					
			skeleton.setJoints(joints);

			skeleton.setSkeletonData(this);
			
			return skeleton;
		}

		#endregion
	}
}
