using System;
using System.Collections.Generic;
using System.Text;

namespace SkeletalAnimation
{
	public class Vector {
		
		private double[] values;

		/**
		 * Default Constructor
		 */
		public Vector() {
			values = new double[3];
		}

		/**
		 * Copy Constructor
		 */
		public Vector(Vector vector) {
			values = new double[3];

			values[0] = vector[0];
			values[1] = vector[1];
			values[2] = vector[2];
		}

		/**
		 * Indexer
		 */
		public double this[int index] {
			get {
				return values[index];
			}
			set {
				values[index] = value;
			}
		}

		/**
		 * Overloading the multiplication operator.
		 */
		public static double operator *(Vector left, Vector right) {
			return left[0]*right[0] + left[1]*right[1] + left[2]*right[2];
		}

		/**
		 * Cross product of two vectors
		 */
		public static Vector crossProduct(Vector left, Vector right) {
			Vector ret = new Vector();

			ret[0] = left[1]*right[2] - left[2]*right[1];
			ret[1] = left[2]*right[0] - left[0]*right[2];
			ret[2] = left[0]*right[1] - left[1]*right[0];

			return ret;
		}
	}
}
