using System;
using System.Collections.Generic;
using System.Text;
using Tao.OpenGl;

namespace Util {
	
	public class Camera {

		private Vector position;
		private double yaw;
		private double pitch;

		/**
		 * Default Constructor
		 */
		public Camera() {
			position = null;
			yaw = 0.0;
			pitch = 0.0;
		}

		public void setPosition(Vector pos) { position = pos; }

		public void updateYaw(double update) {
			this.yaw += update;
		}

		public void setYaw(double value) {
			this.yaw = value;
		}

		public void updatePitch(double update) {
			this.pitch += update;
			if(pitch > 90.0) {
				pitch = 90.0;
			}
			else if(pitch < -90.0) {
				pitch = -90.0;
			}
		}

		public void setPitch(double value) {
			if(value > 90.0) {
				value = 90.0;
			}
			else if(value < -90.0) {
				value = -90.0;
			}
			this.pitch = value;
		}
		
		public void lookThrough() {
			Gl.glTranslated(-position[0], -position[1], -position[2]);
			Gl.glRotated(pitch, 1.0, 0.0, 0.0);
			Gl.glRotated(yaw, 0.0, 1.0, 0.0);
		}
	}
}
